/* Ver 0.00 */
#include <stdio.h>
#include <errno.h>
#include <sys/dev.h>
#include <sys/kernel.h>

/* Docs
The following are reasons for the Send to fail. See Send()
for more information about why the failure occurred.
EAGAIN
EFAULT
EHOSTUNREACH
EINTR
EINVAL
ENOMEM
ESRCH

The following are reasons for dev_info() to fail. See dev_info()
for more information about why the failure occurred.
ENOSYS
EBADF

Other failures:
ENODEV	Not a Dev.cti or Dev.nt960 port *OR* Dev.cti/Dev.nt960 driver
        not on this node.

*/

static struct _dev_info_entry info;

struct	_msg	{
	msg_t	type;
	msg_t	sub_type;
	unsigned short port;
};

static struct _msg msg;

#define	QUERY_TX_FINISHED	23

cti_tcdrain( int fildes )
{
	int status;
	status = dev_info( fildes, &info );
	fprintf( stderr, "dev_info status %d\n", status );
	if (status == 0) {
		msg.type = 'U';
		msg.sub_type = QUERY_TX_FINISHED;
		msg.port = info.unit - 1;
		if (info.nid != getnid()) {
			fprintf( stderr, "getnid error\n" );
			return( ENODEV );
		}
		status = Send( info.driver_pid, &msg, &msg,
			sizeof( struct _msg ), sizeof( struct _msg ) );
	}
	return( status );
}

#ifdef MAIN
main()
{
	int	status;

	status = cti_tcdrain( fileno( stdout ));

	fprintf( stderr, "Status is %d\n", status );
}
#endif
